#include <MessageWindow.h>
#include <qtabwidget.h>
#include <iostream>

MessageWindow::MessageWindow(QWidget *parent)
	: QWidget(parent)
{
	parwidget = (QTabWidget*)parent;	//UNSAFE.
	
	output = new QTextEdit(this);
	output->setFont(QFont(QString("Courier New")));
	output->setReadOnly(true);

	mainlayout = new QVBoxLayout(this, 2);
	mainlayout->addWidget(output);

	buttonlayout = new QHBoxLayout(mainlayout);
	buttonlayout->setAlignment(AlignLeft);
	clear = new QPushButton("Clear", this);
	clear->setMaximumWidth(120);
	QWidget::connect(clear, SIGNAL(clicked()), output, SLOT(clear()));
	buttonlayout->addWidget(clear);

	Compiler::SetNotifiable(this);
	//Object::SetGlobalNotifiable(this);
}

MessageWindow::~MessageWindow()
{
	delete clear;
	delete output;
	delete buttonlayout;
	delete mainlayout;
}

void MessageWindow::PrintError(const QString &error)
{
	QString str = output->text();
	str += "<b><font color=red>:&gt; ";
	str += error;
	str += "</font></b><br>";
	output->setText(str);
	output->scrollToBottom();

	parwidget->showPage(this);

	std::cout << (const char*)error << "\n";
}

void MessageWindow::PrintWarning(const QString &warning)
{
	QString str = output->text();
	str += "<b><font color=blue>:&gt; ";
	str += warning;
	str += "</font></b><br>";
	output->setText(str);
	output->scrollToBottom();

	parwidget->showPage(this);

	std::cout << (const char*)warning << "\n";
}

void MessageWindow::PrintText(const QString &text)
{
	QString str = output->text();
	str += ":&gt; ";
	str += text;
	str += "<br>";
	output->setText(str);
	output->scrollToBottom();

	parwidget->showPage(this);

	std::cout << (const char*)text << "\n";
}
