#include <TraceWindow.h>
#include <Object.h>
#include <Index.h>
#include <Conversion.h>
#include <qtabwidget.h>
#include <iostream>

TraceWindow::TraceWindow(QWidget *parent)
	: QWidget(parent)
{
	parwidget = (QTabWidget*)parent;

	trace = new QListView(this);
	trace->addColumn("Object");
	trace->addColumn("Attribute");
	trace->addColumn("Value");

	objpath = new QLabel(" Tracing: null(null)", this);
	//objpath->setPaletteBackgroundColor(QColor("white"));
	objpath->setFont(QFont("Courier New", 12, QFont::Bold));

	mainlayout = new QVBoxLayout(this, 2);
	mainlayout->addWidget(objpath);
	mainlayout->addWidget(trace);
	buttonlayout = new QHBoxLayout(mainlayout);
	buttonlayout->setAlignment(AlignLeft);

	Object *traceobj;
	Object *object = Object::Lookup(Device_Ide);
	if (object != 0)
	{
		object->Open();
		traceobj = new Object();
		object->Set(Index::Lookup("trace"), traceobj->GetOID());
		object->Close(false);

		traceobj->Open();
		traceobj->AddNotifiable(this, 0);
		traceobj->Close();
	}

	o = Null;
	a = Null;
}

TraceWindow::~TraceWindow()
{
	//delete label;
	//delete trace;
	//delete buttonlayout;
	//delete mainlayout;
}

void TraceWindow::OnChange(OID obj, OID key, OID value)
{
	if (key == Index::Lookup("object"))
	{
		o = value;
		char buf1[50];
		char buf2[50];
		OIDToString(o, buf1, 49);
		OIDToString(a, buf2, 49);
		objpath->setText(QString().sprintf(" Tracing: %s(%s)", buf1, buf2));
	}
	else if (key == Index::Lookup("attribute"))
	{
		a = value;
		char buf1[50];
		char buf2[50];
		OIDToString(o, buf1, 49);
		OIDToString(a, buf2, 49);
		objpath->setText(QString().sprintf(" Tracing: %s(%s)", buf1, buf2));
		parwidget->showPage(this);
	}
}
