#ifndef _CONVERSION_
#define _CONVERSION_

#include <OID.h>
#include <Object.h>
#include <Index.h>
#include <iostream>

namespace doste
{
	extern OID IntToObj(int value);
	
	extern int ObjToInt(OID o);
	
	extern OID CharToObj(char value);
	
	extern char ObjToChar(OID o);
	
	extern OID FloatToObj(float value);
	
	extern float ObjToFloat(OID o);
	
	extern OID BoolToObj(bool value);
	
	extern bool ObjToBool(OID o);

	extern char *OIDToString(OID o, char *buffer, int size);
	
	extern OID StrToObj(const char *str);
	
	extern char *ObjToStr(OID o, char *buf, int bufsize, bool quotes=false);

	extern OID StringToOID(const char *str);

	extern char *DisplayObject(OID obj, char *buffer, int maxsize, int tabs);

	extern char *DefToString(vector<OID> *def, char *buffer, int maxsize, int tabs=0);
};


std::ostream &operator<<(std::ostream &in, const doste::OID &o);

#endif 
