#ifndef _EVENTPROCESSOR_
#define _EVENTPROCESSOR_

#define MAX_EVENTS	100

namespace doste
{
	class Event
	{
		public:
			unsigned char type;

			static const unsigned char NONE = 0;
			static const unsigned char SET = 1;
			static const unsigned char GET = 2;
	};

	class EventProcessor
	{
		public:
			EventProcessor();
			~EventProcessor();

			Event *Allocate();
			void Process(Event *e);

		private:
			list<Event*> m_freeevents;
			list<Event*> m_equeue;
			pthread_t m_qthread;
			pthread_mutex_t m_qmutex;
			pthread_cond_t m_qcond;
			bool m_iswaiting;

			static void *ThreadFunc(void *p);
			void ProcessEvents();
	};
};

#endif
