#ifndef _GUIFACTORY_
#define _GUIFACTORY_

#include <objects/DWidget.h>
#include <qwidget.h>
#include <qfont.h>
#include <qcolor.h>

#define OBJTYPE_UNKNOWN			0
#define OBJTYPE_INTEGER			1
#define OBJTYPE_FLOAT			2
#define OBJTYPE_NULL			3
#define OBJTYPE_BOOLEAN			4
#define OBJTYPE_INDEX			5
#define OBJTYPE_DEV_SCREEN		6
#define OBJTYPE_DEV_CONSOLE		7
#define OBJTYPE_DEV_CORE		8
#define OBJTYPE_DEV_IDE			9
#define OBJTYPE_DEV_CLOCK		10
#define OBJTYPE_SYSTEM			11
#define OBJTYPE_CHAR			12
#define OBJTYPE_VKEY			13
#define OBJTYPE_SPECIAL			14
#define OBJTYPE_STRING			15
#define OBJTYPE_FONT			16
#define OBJTYPE_COLOR			17
#define OBJTYPE_WINDOW			18
#define OBJTYPE_BUTTON			19
#define OBJTYPE_LABEL			20
#define OBJTYPE_GROUPBOX		21
#define OBJTYPE_OPENGL			22
#define OBJTYPE_LINEEDIT		23
#define OBJTYPE_LINE			24
#define OBJTYPE_RECTANGLE		25
#define OBJTYPE_CIRCLE			26
#define OBJTYPE_VECTOR			27
#define OBJTYPE_POLYGON			28
#define OBJTYPE_MODEL			29
#define OBJTYPE_LIGHT			30
#define OBJTYPE_DOCUMENT		31
#define OBJTYPE_IMAGE			32
#define OBJTYPE_OBJECT			33
#define OBJTYPE_CURRENT			34
#define OBJTYPE_TEXTURE			35

#define NUM_OBJTYPES	35

class GUIFactory
{
	public:
		static int IdentifyType(OID obj, OID key);

		static DWidget *CreateWidget(OID type, OID par, OID key, OID obj, QWidget *parent);
		static void CreateFont(OID obj, QFont &font);
		static void CreateColor(OID obj, QColor &color);
};

#endif
