#ifndef _INDEX_
#define _INDEX_

#include <OID.h>

#define INDEX_HASH_SIZE			2000

using namespace doste;

namespace doste
{
	struct IndexEntry
	{
		char *name;
		OID value;
		IndexEntry *next;
	};
	
	class Index
	{
		public:
			static void Init();
			static void Final();
	
			static OID Add(const char *word);
			static OID Add(OID o, const char *word);
			static OID Lookup(const char *word);
			static char *Lookup(OID o);
	
		private:
			static int HashIndex(const char *word);
			static IndexEntry *m_indexhash[INDEX_HASH_SIZE];
			static int lastindex;
	};
};

#endif
