#ifndef _INPUTWINDOW_
#define _INPUTWINDOW_

#include <qwidget.h>
#include <qpushbutton.h>
#include <Compiler.h>
#include <qlayout.h>
#include <Syntax.h>
#include <qtextedit.h>
#include <qtextstream.h>
#include <stdio.h>
#include <stdlib.h>

class InputWindow : public QWidget
{
	Q_OBJECT

	public:
		InputWindow(QWidget *parent);
		~InputWindow();

		void LoadFile(QString &file);
		void SaveFile(QString &file);

		bool hasSelected() { return input->hasSelectedText(); };
		bool hasUndo() { return input->isUndoAvailable(); };
		bool hasRedo() { return input->isRedoAvailable(); };

	public slots:
		void editPaste() { input->paste(); };
		void editCopy() { input->copy(); };
		void editCut() { input->cut(); };
		void editSelectall() { input->selectAll(); };
		void editClear() { input->removeSelectedText(); };
		void editSelectNone() { input->removeSelection(); };
		void editUndo() { input->undo(); };
		void editRedo() { input->redo(); };

	private:
		QTextEdit *input;
		QPushButton *accept;
		QPushButton *clear;
		QBoxLayout *mainlayout;
		QBoxLayout *buttonlayout;
		Syntax *syn;

	private slots:
		void acceptclick();
};

#endif
