#ifndef _MAINFORM_
#define _MAINFORM_

#include <qmainwindow.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qlayout.h>
#include <Compiler.h>
#include <qsplitter.h>
#include <InputWindow.h>
#include <MessageWindow.h>
#include <qtabwidget.h>
#include <ObjectTree.h>
#include <objects/Screen.h>
#include <qfiledialog.h>
#include <TraceWindow.h>
#include <MonitorWindow.h>
#include <objects/Clock.h>
#include <Object.h>
#include <ObjectNotifiable.h>
#include <ObjectWindow.h>
#include <AttributeWindow.h>
#include <ObjectWindow.h>

#define MAX_INPUTS 20

class MainForm : public QMainWindow, public Object, public ObjectNotifiable
{
	Q_OBJECT

	QBoxLayout *mainlayout;

	QMenuBar *menu;

	Clock *timer;

	InputWindow *inputwin;
	InputWindow *ciwin;
	TraceWindow *tracewin;
	MessageWindow *msgwin;
	MonitorWindow *monitorwin;
	QSplitter *splitver;
	QSplitter *splithor;
	QTabWidget *mtabs;
	QTabWidget *itabs;
	Screen *screen;
	ObjectTree *objtree;
	QPopupMenu *edit;

	AttributeWindow *attribs[MAX_ATTRIBUTES];
	InputWindow *inputs[MAX_INPUTS];
	ObjectWindow *objects[MAX_OBJECTS];
	int curinput;
	OID objectobj;
	OID attribobj;

	public:
		MainForm(QWidget *parent=0, const char *name=0);
		~MainForm();

		void OnChange(OID obj, OID attrib, OID value);
		void OnGarbage(OID obj);

		void MakeMenu();

	private slots:
		void fileNew();
		void fileOpen();
		void fileRun();
		void fileSave();
		void fileClose();
		void fileSaveObjects();
		void editAboutToShow();
};

#endif 
