#ifndef _OID_
#define _OID_

#define OID_TYPE_SPECIAL	1
#define OID_TYPE_INTEGER	2
#define OID_TYPE_FLOAT		3
#define OID_TYPE_DEF		4
#define OID_TYPE_CHAR		5
#define OID_TYPE_INDEX		6
#define OID_TYPE_BASE		0
#define OID_TYPE_VKEY		7
#define OID_TYPE_DEVICE		8

#include <iostream>

namespace doste
{
	struct OID
	{
		unsigned char type;
		unsigned int value;
	};

	inline static bool operator==(OID a1, OID a2)
	{
		if (a1.type != a2.type) return false;
		if (a1.value != a2.value) return false;
		return true;
	};

	inline static bool operator!=(OID a1, OID a2)
	{
		if (a1.type != a2.type) return true;
		if (a1.value != a2.value) return true;
		return false;
	};

	inline static OID Integer(int v)
	{
		OID res;
		res.type = OID_TYPE_INTEGER;
		res.value = v;
		return res;
	}

	static const OID Null = {OID_TYPE_SPECIAL,0};
	static const OID True = {OID_TYPE_SPECIAL,1};
	static const OID False = {OID_TYPE_SPECIAL,2};
	static const OID System = {OID_TYPE_SPECIAL,3};
	static const OID Current = {OID_TYPE_SPECIAL,4};
	static const OID This = {OID_TYPE_SPECIAL, 5};
	static const OID Size = {OID_TYPE_SPECIAL, 6};
	static const OID Parent = {OID_TYPE_SPECIAL, 7};
	static const OID Star = {OID_TYPE_SPECIAL, 8};
	static const OID Error = {OID_TYPE_SPECIAL, 9};
	static const OID Infinity = {OID_TYPE_SPECIAL, 10};
};

#include <Devices.h>

#endif 
