#ifndef _OBJECTWINDOW_
#define _OBJECTWINDOW_

#include <Object.h>
#include <qwidget.h>
#include <ObjectNotifiable.h>
#include <qlistview.h>

#define MAX_OBJECTS	5

namespace doste
{
	class AttribItem : public QListViewItem
	{
		public:
			AttribItem(OID key, OID attrib, QListView *parent);
			AttribItem(OID key, OID attrib, QListViewItem *parent);
			~AttribItem();

			void Update(OID key, OID attrib);
			OID GetKey();

		private:
			OID key;
			OID attrib;
	};

	class ObjectWindow : public QWidget, public ObjectNotifiable
	{
		Q_OBJECT

		public:
			ObjectWindow(OID obj, OID par, int num, QWidget *parent);
			~ObjectWindow();

			void OnChange(OID obj, OID key, OID value);
			void OnGarbage(OID obj);

		private:
			OID obj;
			OID par;
			int num;
			QListView *attribs;

		private slots:
			void close();
	};
};

#endif
