#ifndef _OBSERVABLE_
#define _OBSERVABLE_

#include <OID.h>
#include <list>
#include <vector>

using namespace doste;
using namespace std;

struct SDependant
{
	OID object;
	OID attrib;
};

#define FLAG_NONE		0x00
#define FLAG_HIDDEN		0x01

namespace doste
{
	bool operator==(SDependant d1, SDependant d2);

	class Observable
	{
		public:
			Observable();
			~Observable();

			bool Set(OID value);
			OID Get(OID obj = Null, bool eval=false);
			void Define(vector<OID> *def);
			vector<OID> *GetDefinition();
			list<SDependant> *GetDependants();
			void AddDependant(OID object, OID attrib);
			void RemoveDependant(OID object, OID attrib);
			bool OnNotify(OID obj, OID key, void *thi);		//Notify and then remove all dependants.

			unsigned char GetFlags();
			void SetFlags(unsigned char flags);

			void NotifyDependants();

		private:
			OID Evaluate(OID obj, OID key);
			OID Evaluate(OID object, OID key, vector<OID> *def);

			list<SDependant> *dependants;
			bool selfdep;
			OID value;
			unsigned char flags;
			vector<OID> *definition;	//Nest using special OID!!! NOT SAFE.
	};
};

#endif 
