#ifndef _ENTITIES_
#define _ENTITIES_
#include <Object.h>

namespace doste
{
	class Entity : public ObjectNotifiable
	{
		public:
			Entity(OID par, OID key, OID obj)
			{
				this->par = par;
				this->key = key;
				this->obj = obj;
			};
			virtual ~Entity() {};

			virtual void Draw() {};
			virtual void OnChange(OID obj ,OID key, OID value) {};
			virtual void OnGarbage(OID obj) {};
			virtual bool IsGarbage() { return false; };

			static Entity *CreateEntity(OID type, OID parent, OID key, OID object);

			OID par, key, obj;
	};

	struct Vertex
	{
		float x, y, z;
	};

	class PolyVertex : public ObjectNotifiable
	{
		public:
			PolyVertex(OID obj);
			~PolyVertex();

			OID obj;
			Vertex pos;
			Vertex col;
			float u, v;

			void OnChange(OID obj, OID key, OID value);
	};

	class CustomEntity : public Entity
	{
		public:
			CustomEntity(OID par, OID key, OID obj);
			~CustomEntity();

			void Draw();
			void OnChange(OID obj, OID key, OID value);
			//void OnGarbage(OID obj);

		private:
			list<Entity*> entities;
			OID posobj, rotobj;
			Vertex position;
			Vertex rotation;
			bool haslist;
			bool displist;
			unsigned int gllist;
	};

	class Polygon : public Entity
	{
		public:
			Polygon(OID par, OID key, OID obj);
			~Polygon();

			void Draw();
			void OnChange(OID obj, OID key, OID value);
			void OnGarbage(OID obj);
			bool IsGarbage() { return garbage; };

		private:
			bool garbage;
			vector<PolyVertex*> vertices;
			Vertex position;
			Vertex rotation;
			OID rotobj, posobj;
			OID texobj;
			unsigned int texid;
	};
};

#endif
