#include <Compiler.h>
#include <Object.h>
#include <qapplication.h>
#include <MainForm.h>
#include <Index.h>

QApplication *app;

int main(int argc, char **argv)
{
	QApplication a(argc, argv);
	app = &a;

	Index::Init();
	Object::Init();
	Compiler::Init();
	//Universe::Init();

	Compiler::ExecuteFile("boot.dos");

	MainForm *m = new MainForm(0, "doste");
	m->setGeometry(0,0,800,600);
	m->setCaption("DOSTE v2");
	m->setIcon(QPixmap("icons/doste.png"));
	a.setMainWidget(m);
	m->show();

	//Process command line arguments
	for (int i=1; i<argc; i++)
	{
		if (argv[i][0] != '-')
		{
			Compiler::ExecuteFile(argv[i]);
		}
	}

	int res = a.exec();
	m->hide();
	m->Close();

	

	//Universe::Final();
	Compiler::Final();
	Object::Final();
	Index::Final();

	return 0;
}
