#include <objects/Base.h>
#include <Conversion.h>
#include <Index.h>

using namespace doste;

Union::Union(OID parent, bool def) : Object()
{
	this->def = def;
	Open();
	Set(Parent, parent);
	Close(false);
}

Union::~Union()
{
}

void Union::AddDependant(OID o1, OID o2, OID o3)
{
}

OID Union::Get(OID attrib)
{
	if (attrib == Parent)
		return Object::Get(attrib);

	std::cout << "UNION\n";

	Object *newobj = new Object();
	Object *parent = Object::Lookup(Get(Parent));
	Object *attobj = Object::Lookup(attrib);
	if (parent == 0)
	{
		delete newobj;
		return Null;
	}

	char *buffer = new char[10000];

	newobj->Open();
	parent->Open();

	int i=0;
	OID key = parent->GetAttribute(i);
	while (key != Error)
	{
		newobj->Set(key, parent->Get(key));
		newobj->SetFlags(key, parent->GetFlags(key));
		if (def && parent->GetDefinition(key) != 0)
		{
			DefToString(parent->GetDefinition(key), buffer, 10000);
			newobj->Set(key, Compiler::CompileDefinition(buffer, newobj->GetOID()));
		}
		i++;
		key = parent->GetAttribute(i);
	}
	
	parent->Close();

	if (attobj != 0)
	{
		attobj->Open();
		i = 0;
		key = attobj->GetAttribute(i);
		while (key != Error)
		{
			newobj->Set(key, attobj->Get(key));
			newobj->SetFlags(key, attobj->GetFlags(key));
			if (def && attobj->GetDefinition(key) != 0)
			{
				DefToString(attobj->GetDefinition(key), buffer, 10000);
				newobj->Set(key, Compiler::CompileDefinition(buffer, newobj->GetOID()));
			}
			i++;
			key = attobj->GetAttribute(i);
		}
		attobj->Close();
	}

	delete [] buffer;

	newobj->Close(false);
	return newobj->GetOID();
}
