#include <objects/Clock.h>
#include <Conversion.h>
#include <Index.h>

Clock::Clock()
	: QTimer(), Object(Device_Clock)
{
	Open();
	Set(Index::Lookup("interval"), IntToObj(100));
	AddNotifiable(this, 0);
	connect(this, SIGNAL(timeout()), this, SLOT(timeevent()));
	Set(Index::Lookup("enabled"), True);
}

Clock::~Clock()
{
}

void Clock::timeevent()
{
	Open();
	Set(Index::Lookup("tick"), True);
	Set(Index::Lookup("tick"), False);
	Close();
}

void Clock::OnChange(OID obj, OID attrib, OID value)
{
	if (attrib == Parent)
		return;

	if (attrib == Index::Lookup("interval"))
	{
		if (value.type == OID_TYPE_INTEGER && isActive())
			changeInterval(value.value);
	} else if (attrib == Index::Lookup("enabled"))
	{
		if (value == True && isActive() == false)
			start(ObjToInt(Get(Index::Lookup("interval"))));
		else
			if (isActive())
				stop();
	}
} 
