#include <objects/DButton.h>
#include <Index.h>
#include <Conversion.h>
#include <iostream>

DButton::DButton(OID par, OID key, OID obj, QWidget *parent)
	: QPushButton("BUTTON", parent), DWidget(par, key, obj)
{
	connect(this, SIGNAL(clicked()), this, SLOT(clicked()));
	LoadObject();
	show();
}

DButton::~DButton()
{
}


void DButton::OnChange(OID obj, OID attrib, OID value)
{
	if (attrib == Index::Lookup("width"))
	{
		if (value.type == OID_TYPE_INTEGER)
			resize(value.value, height());
	}
	else if (attrib == Index::Lookup("height"))
	{
		if (value.type == OID_TYPE_INTEGER)
			resize(width(), value.value);
	}
	else if (attrib == Index::Lookup("x"))
	{
		if (value.type == OID_TYPE_INTEGER)
			move(value.value, y());
	}
	else if (attrib == Index::Lookup("y"))
	{
		if (value.type == OID_TYPE_INTEGER)
			move(x(), value.value);
	}
	else if (attrib == Index::Lookup("text"))
	{
		char buf[1000];
		setText(ObjToStr(value, buf, 1000));
	}
	else if (attrib == Index::Lookup("enabled"))
	{
		setEnabled(ObjToBool(value));
	}
}

void DButton::clicked()
{
	Object *wid = Object::Lookup(object);
	if (wid != 0)
	{
		wid->Open();
		wid->Set(Index::Lookup("onclick"), True);
		wid->Set(Index::Lookup("onclick"), False);
		wid->Close();
	}
}
