#include <objects/DLabel.h>
#include <Index.h>
#include <Conversion.h>
#include <GUIFactory.h>

DLabel::DLabel(OID par, OID key, OID obj, QWidget *parent)
	: QLabel("LABEL", parent), DWidget(par, key, obj)
{
	//connect(this, SIGNAL(clicked()), this, SLOT(clicked()));
	LoadObject();
	show();
}

DLabel::~DLabel()
{
}

void DLabel::OnChange(OID obj, OID attrib, OID value)
{
	if (obj == m_font)
	{
		QFont font;
		GUIFactory::CreateFont(obj, font);
		setFont(font);
		return;
	}

	if (obj == m_color)
	{
		QColor color;
		GUIFactory::CreateColor(obj, color);
		setPaletteForegroundColor(color);
		return;
	}

	if (attrib == Index::Lookup("width"))
	{
		if (value.type == OID_TYPE_INTEGER)
			resize(value.value, height());
	}
	else if (attrib == Index::Lookup("height"))
	{
		if (value.type == OID_TYPE_INTEGER)
			resize(width(), value.value);
	}
	else if (attrib == Index::Lookup("x"))
	{
		if (value.type == OID_TYPE_INTEGER)
			move(value.value, y());
	}
	else if (attrib == Index::Lookup("y"))
	{
		if (value.type == OID_TYPE_INTEGER)
			move(x(), value.value);
	}
	else if (attrib == Index::Lookup("text"))
	{
		char buf[1000];
		setText(ObjToStr(value, buf, 1000));
	}
	else if (attrib == Index::Lookup("font"))
	{
		QFont font;
		GUIFactory::CreateFont(value, font);
		setFont(font);
		m_font = value;
		Object *object = Object::Lookup(value);
		if (object != 0)
		{
			object->Open();
			object->AddNotifiable(this,0);
			object->Close();
		}
	}
	else if (attrib == Index::Lookup("colour"))
	{
		QColor color;
		GUIFactory::CreateColor(value, color);
		setPaletteForegroundColor(color);
		m_color = value;
		Object *object = Object::Lookup(value);
		if (object != 0)
		{
			object->Open();
			object->AddNotifiable(this,0);
			object->Close();
		}
	}
} 
