#include <objects/DLineEdit.h>
#include <Index.h>
#include <Conversion.h>
#include <iostream>

using namespace doste;

DLineEdit::DLineEdit(OID par, OID key, OID obj, QWidget *parent)
	: QLineEdit(parent), DWidget(par,key,obj)
{
	connect(this, SIGNAL(textChanged(const QString&)), this, SLOT(textChanged(const QString&)));
	connect(this, SIGNAL(returnPressed()), this, SLOT(returnPressed()));
	LoadObject();
	show();
}

DLineEdit::~DLineEdit()
{
}

void DLineEdit::OnChange(OID obj, OID attrib, OID value)
{
	if (attrib == Index::Lookup("width"))
	{
		if (value.type == OID_TYPE_INTEGER)
			resize(value.value, height());
	}
	else if (attrib == Index::Lookup("height"))
	{
		if (value.type == OID_TYPE_INTEGER)
			resize(width(), value.value);
	}
	else if (attrib == Index::Lookup("x"))
	{
		if (value.type == OID_TYPE_INTEGER)
			move(value.value, y());
	}
	else if (attrib == Index::Lookup("y"))
	{
		if (value.type == OID_TYPE_INTEGER)
			move(x(), value.value);
	}
	else if (attrib == Index::Lookup("text"))
	{
		char buf[1000];
		setText(ObjToStr(value, buf, 1000));
	}
}

void DLineEdit::textChanged(const QString &text)
{
	Object *wid = Object::Lookup(object);
	if (wid != 0)
	{
		wid->Open();
		wid->Set(Index::Lookup("text"), StrToObj(text));
		wid->Close();
	}
	
}

void DLineEdit::returnPressed()
{
	Object *wid = Object::Lookup(object);
	if (wid != 0)
	{
		wid->Open();
		wid->Set(Index::Lookup("onreturn"), BoolToObj(true));
		wid->Set(Index::Lookup("onreturn"), BoolToObj(false));
		wid->Close();
	}
}

 
