#include <GUIFactory.h>
#include <objects/DNone.h>
#include <Index.h>
#include <qwidget.h>
#include <Conversion.h>
#include <qobjectlist.h>

DNone::DNone(OID pare, OID key, OID obj, QWidget *par)
	: DWidget(pare, key, obj)
{
	parent = par;
	LoadObject();
}

DNone::~DNone()
{
}

void DNone::OnChange(OID obj, OID attrib, OID value)
{
	if (attrib == Parent)
		return;
	if (attrib == Index::Lookup("widget"))
		return;

	for (list<DWidget*>::iterator i=children.begin(); i!=children.end(); i++)
	{
		if ((*i)->GetKey() == attrib)
		{
			delete (*i);
			children.erase(i);
		}
	}

	Object *obje = Object::Lookup(value);
	if (obje != 0)
	{
		obje->Open();
		OID wtype = obje->Get(Index::Lookup("widget"));
		if (wtype == Error || wtype == Null)
		{
			obje->Close();
			return;
		}

		DWidget *wid = GUIFactory::CreateWidget(wtype, obj, attrib, value, parent);
		if (wid != 0)
			children.push_front(wid);

		obje->Close();
	}
} 
