#include <objects/DWindow.h>
#include <GUIFactory.h>
#include <Index.h>
#include <Conversion.h>
#include <iostream>

DWindow::DWindow(OID par, OID key, OID obj, QWidget *parent)
	: DWidget(par, key, obj), QWidget(parent)
{
	LoadObject();
	show();
}

DWindow::~DWindow()
{
}

void DWindow::OnChange(OID obj, OID attrib, OID value)
{
	if (attrib == Parent)
		return;
	if (attrib == Index::Lookup("widget"))
		return;

	if (attrib == Index::Lookup("width"))
	{
		if (value.type == OID_TYPE_INTEGER)
			resize(value.value, height());
	}
	else if (attrib == Index::Lookup("height"))
	{
		if (value.type == OID_TYPE_INTEGER)
			resize(width(), value.value);
	}
	else if (attrib == Index::Lookup("x"))
	{
		if (value.type == OID_TYPE_INTEGER)
			move(value.value, y());
	}
	else if (attrib == Index::Lookup("y"))
	{
		if (value.type == OID_TYPE_INTEGER)
			move(x(), value.value);
	}
	else if (attrib == Index::Lookup("bgcolour"))
	{
		char buf[1000];
		setPaletteBackgroundColor(QColor(ObjToStr(value, buf, 1000)));
	}
	else
	{
		for (list<DWidget*>::iterator i=children.begin(); i!=children.end(); i++)
		{
			if ((*i)->GetKey() == attrib)
			{
				delete (*i);
				children.erase(i);
			}
		}
		
		Object *obje = Object::Lookup(value);
		if (obje != 0)
		{
			obje->Open();
			OID wtype = obje->Get(Index::Lookup("widget"));
			if (wtype == Error || wtype == Null)
			{
				obje->Close();
				return;
			}

			DWidget *widget = GUIFactory::CreateWidget(wtype, obj, attrib, value, this);

			if (widget != 0)
			{
				children.push_front(widget);
			}
			obje->Close();
		}
	}
}
 
